/*
 * runningavg.cxx
 * 
 * This program calculates partial averages, it takes in input
 * the current partial average, the number of elements and the next value.
 * 
 * Copyright 2014 Florido Paganelli <pflorido@tjatte>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#include <iostream>
#include <string>
#include <stdlib.h>
using namespace std;

int main(int argc, char **argv)
{
	// the first parameter is the partial average so far.
	float partialaverage = atof(argv[1]);
	// the second parameter is the current number of elements including 
	// the new value
	float elements = atof(argv[2]);
	// the third parameter is the new value we want to update 
	// the average with
	float newvalue = atof(argv[3]);
	// the result will be put in this variable
	float average = 0.0;
	// prevent division by zero, an average over no elements does not
	// make any sense.
	if (elements > 0.0) 
	{
		// this formula can be derived from the average formula.
		// for a discussion see 
		// http://math.stackexchange.com/questions/106700/incremental-averageing
		average = partialaverage + ((newvalue - partialaverage) / elements );
	}
	else {
		cout << "elements must be > 1! Exiting..." << endl;
		return 0;
		}
	// print out the found average
	cout << average;
	
	return 0;
}

