#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#  exerciseD6.5.first.py
#  
#  Copyright 2014 Florido Paganelli <florido.paganelli@hep.lu.se>
#  
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.

# library for listing files in a directory using substitution
import glob;
# library to work with csv files
import csv;
# library to call operating systems functions (e.g. open files)
import os;
# library to print datastructures in a nice way
import pprint;

def createdb(dirpath):
	# create a temporary database, only visible in the scope of the function
	tempdb = []
	# list all files in the directory contained in the variable dirpath
	dirs = glob.glob(dirpath)
	for files in dirs:
		# for each file in the directory, call it csvfile
		with open(files,'r') as csvfile:
			# use the csv library that helps parsing the files
			csvreader = csv.reader(csvfile, delimiter=',', quotechar='\"');
			# the first row is the header, we should only include it once
			# firstrow is called a "flag", tell us when the first row comes.
			firstrow=1;
			# this list will contain the header
			headerlist=[]
			# this list will contain the movie information
			elements=[]
			# for each row in the CSV file
			for row in csvreader:
				# if it's the first one, get the names of the columns
				if firstrow:
					headerlist=list(row)
					# we're done with the first row, skip it next time!
					firstrow=0
				# if it is NOT the first row, then add the records to
				# the database.
				else:
					# create a list with elements
					elements=list(row)
					# create a dictionary whose keys are the header,
					# and whose values are the movie values, and add
					# the dictionary to the csv list.
					tempdb.append(dict(zip(headerlist,elements)))
            # close the file
            csvfile.close()
	return tempdb

def main():
	# create a new database as a list
	moviesdb=[];
	# let a function create the database and return it
	moviesdb = createdb('../movies/*')
	# print out the database
	print moviesdb
	pp = pprint.PrettyPrinter(depth=6)
	pp.pprint(moviesdb)
	return 0


if __name__ == '__main__':
	main()

