#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#  exerciseD6.6.py
#  
#  Copyright 2014 Florido Paganelli <florido.paganelli@hep.lu.se>
#  
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.

# library for listing files in a directory using substitution
import glob;
# library to work with csv files
import csv;
# library to call operating systems functions (e.g. open files)
import os;
# library to print datastructures in a nice way
import pprint;

def loadcsv(csvfilehandler):
	# see comments in exerciseD6.4, 
	# it's the same code with different variable names!
	csvdb = []
	csvreader = csv.reader(csvfilehandler, delimiter=',', quotechar='\"');
	firstrow=1;
	headerlist=[]
	elements=[]
	for row in csvreader:
		if firstrow:
			headerlist=list(row)
			firstrow=0
		else:
			elements=list(row)
			csvdb.append(dict(zip(headerlist,elements)))
	return csvdb

def createdb(dirpath):
	# create a temporary database, only visible in the scope of the function
	tempdb = []
	# list all files in the directory contained in the variable dirpath
	dirs = glob.glob(dirpath)
	for files in dirs:
		# for each file in the directory, run the loadcsv function
		with open(files,'r') as csvfile:
			# the + operator merges two lists, at every
			# iteration the current database of movies will be
			# amended with the new movies
			tempdb = tempdb + loadcsv(csvfile)
			# close the file
			csvfile.close()
	return tempdb

def getbyGenre(moviedb,genre):
	# select movies with certain genre and
	# store them in a list
	selection = []
	for movie in moviedb:
		if (genre in movie['Genre']):
			selection.append(movie)
			#print len(selection)
	return selection;

def main():
	# create a new database as a list
	moviesdb=[];
	# let a function create the database and return it
	moviesdb = createdb('./movies/*')
	# extract movies of a certain Genre
	bygenredb = getbyGenre(moviesdb,'Comedy')
	# print out the selected database
	print bygenredb
	pp = pprint.PrettyPrinter(depth=6)
	pp.pprint(bygenredb)
	return 0


if __name__ == '__main__':
	main()

